/*
 * $Id: msges.c,v 1.4 2000/05/02 20:14:18 vszel Exp $
 */

/*
 * Harbour Project source code:
 * Language Support Module (ES)
 *
 * Copyright 2000 Jose Lalin <dezac@corevia.com>
 * www - http://www.harbour-project.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version, with one exception:
 *
 * The exception is that if you link the Harbour Runtime Library (HRL)
 * and/or the Harbour Virtual Machine (HVM) with other files to produce
 * an executable, this does not by itself cause the resulting executable
 * to be covered by the GNU General Public License. Your use of that
 * executable is in no way restricted on account of linking the HRL
 * and/or HVM code into it.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA (or visit
 * their web site at http://www.gnu.org/).
 *
 */

/* Language name: Spanish */
/* ISO language code (2 chars): ES */
/* Codepage: 850 */

#include "hbapilng.h"

static HB_LANG s_lang =
{
   {
      /* Identification */
   
      "ES",                        /* ID */
      "Spanish",                   /* Name (in English) */
      "Espaol",                   /* Name (in native language) */
      "ES",                        /* RFC ID */
      "850",                       /* Codepage */
      "$Revision: 1.4 $ $Date: 2000/05/02 20:14:18 $",         /* Version */
   
      /* Month names */
   
      "Enero",
      "Febrero",
      "Marzo",
      "Abril",
      "Mayo",
      "Junio",
      "Julio",
      "Agosto",
      "Septiembre",
      "Octubre",
      "Noviembre",
      "Diciembre",
   
      /* Day names */

      "Domingo",
      "Lunes",
      "Martes",
      "Mircoles",
      "Jueves",
      "Viernes",
      "Sbado",
   
      /* CA-Cl*pper compatible natmsg items */
   
      "Bases de Datos    # Records    Last Update     Size",
      "Desea Ud. ms ejemplos?",
      "Pgina N.",
      "** Subtotal **",
      "* Subsubtotal *",
      "*** Total ***",
      "Ins",
      "   ",
      "Fecha no vlida",
      "Rango: ",
      " - ",
      "S/N",
      "EXPRESION NO VALIDA",
   
      /* Error description names */
   
      "Error desconocido",
      "Error de argumento",
      "Error de rango",
      "Desbordamiento en cadena de caracteres",
      "Desbordamiento numrico",
      "Divisin por cero",
      "Error numrico",
      "Error de sintaxis",
      "Operacin demasiado compleja",
      "",
      "",
      "Poca memoria",
      "Funcin no definida",
      "No existe el mtodo",
      "No existe la variable",
      "No existe el alias",
      "No existe la variable de instancia",
      "Alias con caracteres no vlidos",
      "Alias actualmente en uso",
      "",
      "Error de creacin",
      "Error de apertura",
      "Error de cierre",
      "Error de lectura",
      "Error de escritura",
      "Error de impresin",
      "",
      "",
      "",
      "",
      "Operacin no soportada",
      "Lmite excedido",
      "Se detect corrupcin",
      "Error de tipo de datos",
      "Error de anchura de datos",
      "Area de trabajo no usada",
      "Area de trabajo no indexada",
      "Se requiere uso exclusivo",
      "Se requiere bloqueo",
      "Escritura no autorizada",
      "Fallo en el bloqueo de adicin",
      "Fallo en bloqueo",
      "",
      "",
      "",
      "",
      "acceso al array",
      "asignacin del array",
      "dimensin del array",
      "no es un array",
      "conditional",
   
      /* Internal error names */
   
      "Error irrecuperable %lu: ",
      "Fallo en recuperacin de error",
      "No hay ERRORBLOCK() para el error",
      "Demasiadas llamadas recursivas al controlador de errores",
      "RDD no vlido  fallo al cargar",
      "Tipo de mtodo no vlido desde %s",
      "hb_xgrab no puede asignar memoria",
      "hb_xrealloc llamado con un puntero nulo",
      "hb_xrealloc llamado con un puntero no vlido",
      "hb_xrealloc no puede reubicar la memoria",
      "hb_xfree llamado con un puntero no vlido",
      "hb_xfree llamado con un puntero nulo",
      "No se puede localizar el procedimiento de inicio: \'%s\'",
      "No hay procedimiento de inicio",
      "Opcode no soportado por la VM",
      "Smbolo item esperado desde %s",
      "Tipo de smbolo para self no vlido desde %s",
      "Bloque de cdigo esperado desde %s",
      "Tipo item incorrecto en la Pila al tratar de sacarlo desde %s",
      "Desbordamiento negativo en la Pila",
      "Un item estaba siendo copiado sobre s mismo desde %s",
      "Smbolo item no vlido pasado como memvar %s",

      /* Texts */

      "YYYY/MM/DD",
      "S",
      "N"
   }
};

HB_LANG_ANNOUNCE( ES );

HB_CALL_ON_STARTUP_BEGIN( hb_lang_Init_ES )
   hb_langRegister( &s_lang );
HB_CALL_ON_STARTUP_END( hb_lang_Init_ES )
#if ! defined(__GNUC__) && ! defined(_MSC_VER)
   #pragma startup hb_lang_Init_ES
#endif

