/*
 * $Id: hbdocdef.ch,v 1.2 2000/04/02 00:21:02 lculik Exp $
 */

/*
 * Harbour Project source code:
 * Header file common definition of HBDOc
 *
 * Copyright 2000 Luiz Rafael Culik <culik@sl.conex.net>
 * www - http://www.harbour-project.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version, with one exception:
 *
 * The exception is that if you link the Harbour Runtime Library (HRL)
 * and/or the Harbour Virtual Machine (HVM) with other files to produce
 * an executable, this does not by itself cause the resulting executable
 * to be covered by the GNU General Public License. Your use of that
 * executable is in no way restricted on account of linking the HRL
 * and/or HVM code into it.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA (or visit
 * their web site at http://www.gnu.org/).
 *
 */
#ifndef _HBDOCDEF_CH_
#define _HBDOCDEF_CH_

#define CRLF HB_OSNewLine()
//  The delimiter
#define DELIM   "$"                 // keyword delimiter

#xtranslate UPPERLOWER(<exp>) => (UPPER(SUBSTR(<exp>,1,1))+LOWER(SUBSTR(<exp>,2)))
#define D_NORMAL  1
#define D_ARG     2
#define D_SYNTAX  3
#define D_IGNORE  4
#define D_SEEALSO 5
#define D_INCLUDE 6
#define D_ONELINE 7
#define D_STATUS  8
#define D_DATALINK 10
#define D_METHODLINK 11
#define D_EXAMPLE 12
#define D_DESCRIPTION 13
#define D_RETURN 14
#define D_COMPLIANCE 15
#define pDOS_HANDLE 1
#define pDOS_FILE   2
#define pDOS_PATH   3
#define pARRAY     "A"
#define pBLOCK     "B"
#define pCHARACTER "C"
#define pDATE      "D"
#define pLOGICAL   "L"
#define pMEMO      "M"
#define pNUMERIC   "N"
#define pOBJECT    "O"
#define pTRUE .t.
#define pFALSE .f.
#define pCRLF HB_OSNEWLINE()

#xtranslate DOSFILENAME(<c>) => substr( <c>, rat("\",<c>)+1 )


#xcommand IF <var> IS <type>          => if valtype(<var>) = <type>
#xcommand IF <var> IS NOT <type>      => if valtype(<var>) != <type>
#xcommand IF <ele> IS IN <array>      => if !(len( <array> ) \< <ele> )
#xcommand IF <ele> IS NOT IN <array>  => if len( <array> ) \< <ele>
#xtranslate (<var> IS <type> )     => (  valtype(<var>) = <type> )
#xtranslate (<var> IS NOT <type>)  => (  valtype(<var>) != <type> )
#define pBUFFER_LENGTH 4096
#endif
